package com.adaapa.adaojek.servlets;

import com.adaapa.adaojek.middlewares.CookieCheck;
import com.adaapa.adaojek.services.ServiceConnector;
import com.adaapa.adaojek.stub.ApplicationCookie;
import com.google.gson.Gson;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import com.adaapa.bean.OrderBean;
import com.adaapa.bean.UserBean;
import com.adaapa.bean.WebServiceBean;


/**
 * Created by ireneedriadr on 11/21/17.
 */
public class ChatDriverServlet extends HttpServlet {
  @Override
  protected void doGet(HttpServletRequest req, HttpServletResponse resp)
          throws ServletException, IOException {
    if (!CookieCheck.redirectIfTokenNotFound(req, resp, "logout")) {
      String pickup = req.getParameter("pickUp");
      String destination = req.getParameter("destination");
      req.setAttribute("pickup", pickup);
      req.setAttribute("destination", destination);
      ApplicationCookie cookie = CookieCheck.getCookie(req);
      req.setAttribute("user", cookie.getUsername());
      Gson gson = new Gson();
      String response = ServiceConnector.getServiceClass().
              findDriverByUsername(cookie.getToken(), req.getParameter("driverId"));
      WebServiceBean wsBean = gson.fromJson(response, WebServiceBean.class);
      if (wsBean.getStatus().equals(WebServiceBean.STATUS_INVALID)) {
        resp.sendRedirect("logout");
      } else {
        UserBean ubean = gson.fromJson(wsBean.getBody(), UserBean.class);
        req.setAttribute("driverProfile", ubean);
        req.getRequestDispatcher("WEB-INF/chat_driver.jsp").forward(req, resp);
      }
    }
  }
}
